package at.linz.semweb.demo;

import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.ResourceFactory;

public class QueryRDF {

	public static void main(String[] args) {
		
		//semantic net lives inside Jena's model
		Model model=ModelFactory.createDefaultModel();

		//you can assert statements if you wish
		model.add(
				ResourceFactory.createResource("http://demo.semweb.linz/person#TomPerson"),
				ResourceFactory.createProperty("http://demo.semweb.linz/person#hasName"),
				ResourceFactory.createTypedLiteral("Tom")
				);

		model.add(
				ResourceFactory.createResource("http://demo.semweb.linz/person#TomPerson"),
				ResourceFactory.createProperty("http://demo.semweb.linz/person#isFriendWith"),
				ResourceFactory.createResource("http://demo.semweb.linz/person#JerryPerson")
				);

		model.add(
				ResourceFactory.createResource("http://demo.semweb.linz/person#JerryPerson"),
				ResourceFactory.createProperty("http://demo.semweb.linz/person#type"),
				ResourceFactory.createResource("http://demo.semweb.linz/person#Student")
				);
		
		//let's create some SPARQL queries - let query for all friends
		QueryExecution qe = QueryExecutionFactory.create(
				"SELECT ?x ?y WHERE {?x <http://demo.semweb.linz/person#isFriendWith> ?y.}",
				model);
		ResultSet rs = qe.execSelect();
		while (rs.hasNext()) {
			System.out.println(rs.nextSolution());
		}
		qe.close();
	}

}
